unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,mmsystem, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);

var
	o:MCI_OPEN_PARMS;  // 
  s:MCI_SET_PARMS;   // 
  
  i:Cardinal;        // 
  str:PChar;         //     
begin
GetMem(str,1024);

//  , :
// animation, cdaudio, dat, digitalvideo, other, overlay, scanner, sequencer, vcr, videodisc, waveaudio
o.lpstrDeviceType:='cdaudio';

//    (    E:\)
o.lpstrElementName:='e';

//   
//    

// 
i:=mciSendCommand(0,MCI_OPEN,MCI_OPEN_ELEMENT or MCI_OPEN_TYPE,LongInt(@o));
mciGetErrorString(i,PChar(str),1024);
memo1.Lines.Add(str);

//  OPEN
i:=mciSendCommand(o.wDeviceID,MCI_SET,MCI_SET_DOOR_OPEN,LongInt(@s));
mciGetErrorString(i,PChar(str),1024);
memo1.Lines.Add(str);

//
i:=mciSendCommand(o.wDeviceID,MCI_CLOSE,0,0);
mciGetErrorString(i,PChar(str),1024);
memo1.Lines.Add(str);

FreeMem(str,1024);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
	o:MCI_OPEN_PARMS;
  s:MCI_STATUS_PARMS;
  
  i:Cardinal;
  str:PChar;
begin
GetMem(str,1024);

//  
o.lpstrDeviceType:='cdaudio';

//    (    E:\)
o.lpstrElementName:='e';


i:=mciSendCommand(0,MCI_OPEN,MCI_OPEN_ELEMENT or MCI_OPEN_TYPE,LongInt(@o));
mciGetErrorString(i,PChar(str),1024);
memo1.Lines.Add(str);

//  
s.dwItem:=MCI_STATUS_MODE;
i:=mciSendCommand(o.wDeviceID,MCI_STATUS,MCI_STATUS_ITEM or MCI_WAIT ,LongInt(@s));
mciGetErrorString(i,PChar(str),1024);
memo1.Lines.Add(str);

i:=mciSendCommand(o.wDeviceID,MCI_CLOSE,0,0);
mciGetErrorString(i,PChar(str),1024);
memo1.Lines.Add(str);

FreeMem(str,1024);

//  memo
case s.dwReturn of
MCI_MODE_NOT_READY: memo1.Lines.Add('NOT_READY');
MCI_MODE_PAUSE:     memo1.Lines.Add('PAUSE');
MCI_MODE_PLAY:      memo1.Lines.Add('PLAY');
MCI_MODE_STOP:      memo1.Lines.Add('STOP');
MCI_MODE_OPEN:      memo1.Lines.Add('OPEN');
MCI_MODE_RECORD:    memo1.Lines.Add('RECORD');
MCI_MODE_SEEK:      memo1.Lines.Add('SEEK');
end;

end;

procedure TForm1.Button3Click(Sender: TObject);
var
  i, mask : integer;
  s : string;
begin
//  
mask := GetLogicalDrives;
i := 0;
while mask<>0 do begin
s:= chr( ord('a') + i ) + ':\';
if (mask and 1) <> 0 then
case GetDriveType(PChar(s)) of
  0               : Memo1.Lines.Add(s + ' unknown.');
  1               : Memo1.Lines.Add(s + ' not exist.');
  DRIVE_REMOVABLE : Memo1.Lines.Add(s + ' removable.'); // floppy,zip
  DRIVE_FIXED     : Memo1.Lines.Add(s + ' fixed.');
  DRIVE_REMOTE    : Memo1.Lines.Add(s + ' network.');
  DRIVE_CDROM     : Memo1.Lines.Add(s + ' CD-ROM.');
  DRIVE_RAMDISK   : Memo1.Lines.Add(s + ' RAM.');
end;
inc(i); mask := mask shr 1;
end;

end;

end.
